using System;
using System.Collections.Generic;
using System.Text;

namespace  SharpProxyService

{
    public class Mod_ReWrite:SharpProxyPlugin 
    {
        public static Config MyConfig;
        public Mod_ReWrite() { }
        PluginVoidResult DoNothing = new PluginVoidResult();

        public override void AfterProxyRequestDisposed(ProxyRequest DisposedRequest)
        {
            
        }
        public override void AfterServerDisconnected(ProxyRequest CurrentRequest)
        {
            
        }
        public override PluginVoidResult BeforeSendDataToClient(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult BeforeSendDataToServer(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override void LoadPluginSettings(string CWD)
        {
            MyConfig = new Config(CWD);
            MyConfig.LoadOrSetDefaults();
        }
        public override PluginVoidResult OnClientConnected(System.Net.Sockets.Socket ClientSocket)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnClientDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override void OnClientDisconnected(System.Net.Sockets.Socket ClientSocket)
        {
            
        }
        public override PluginVoidResult OnFtpDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnNewProxyRequestBuild(ProxyRequest CurrentProxyRequest)
        {
            StringBuilder SB = new StringBuilder();
            bool WriteToLog = false;
            lock (MyConfig.Rules) 
            {

                foreach (Rule R in MyConfig.Rules) 
                {
                    if (MyConfig.Verbose) 
                    {
                        SB.Append("RULE:" + R.URL_LIKE_MASK + "\r\n");
                        SB.Append("URL:" + CurrentProxyRequest.URL + "\r\n");
                        SB.Append("FileName BEFORE:" + CurrentProxyRequest.FileName + "\r\n");
                        if (CurrentProxyRequest.HeadersFields.ContainsKey("USER-AGENT:"))
                        {
                            SB.Append("UA BEFORE:" + (string)CurrentProxyRequest.HeadersFields["USER-AGENT:"] + "\r\n");
                        }
                        else 
                        {
                            SB.Append("UA BEFORE:N/A(not set)\r\n");
                        }
                        if (CurrentProxyRequest.HeadersFields.ContainsKey("REFERER:"))
                        {
                            SB.Append("REFERER BEFORE:" + (string)CurrentProxyRequest.HeadersFields["REFERER:"] + "\r\n");
                        }
                        else
                        {
                            SB.Append("REFERER BEFORE:N/A(not set)\r\n");
                        }
                    }

                    if (R.Apply(CurrentProxyRequest))
                    {

                        if (MyConfig.Verbose)
                        {
                            SB.Append("FileName AFTER :" + CurrentProxyRequest.FileName + "\r\n");
                            if (CurrentProxyRequest.HeadersFields.ContainsKey("USER-AGENT:"))
                            {
                                SB.Append("UA AFTER :" + (string)CurrentProxyRequest.HeadersFields["USER-AGENT:"] + "\r\n");
                            }
                            else
                            {
                                SB.Append("UA AFTER :N/A(not set)\r\n");
                            }
                            if (CurrentProxyRequest.HeadersFields.ContainsKey("REFERER:"))
                            {
                                SB.Append("REFERER AFTER :" + (string)CurrentProxyRequest.HeadersFields["REFERER:"] + "\r\n");
                            }
                            else
                            {
                                SB.Append("REFERER AFTER :N/A(not set)\r\n");
                            }
                        }
                        WriteToLog = true;
                    }
                }
            }
            if (WriteToLog) 
            {
                PluginVoidResult Return = new PluginVoidResult();
                Return.WriteToPluginsLog = SB.ToString();
                return Return;
            }
            return DoNothing;
        }
        public override void OnPlug(List<SharpProxyPlugin> TheAllLoadedPlugins)
        {
            
        }
        public override PluginVoidResult OnProxyRequestDisposing(ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override PluginVoidResult OnServerDataArrived(byte[] BYTES, int BytesCount, ProxyRequest CurrentProxyRequest)
        {
            return DoNothing;
        }
        public override void OnUnPlug(UnplugReason TheReason)
        {
            if (TheForm != null)
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
            MyConfig.Rules.Clear();
            MyConfig = null;
        }
        public override string PluginName
        {
            get { return "MOD ReWrite"; }
        }
        public override System.Collections.Hashtable PluginSettings
        {
            get { return null; }
        }
        public override int PluginVersion
        {
            get { return 1; }
        }
        fSettings TheForm = null;
        public override void Show_Setting_For_User_To_Edit(System.Windows.Forms.Form TheMDIParent_Form)
        {
            if (TheForm != null) 
            {
                try
                {
                    TheForm.Dispose();
                }
                catch { }
            }
            TheForm = new fSettings();
            TheForm.MdiParent = TheMDIParent_Form;
            TheForm.Visible = true;
            TheForm.WindowState = System.Windows.Forms.FormWindowState.Maximized;

            
        }
        public override PluginType TheType
        {
            get { return PluginType.EXTRA_FUNCTIONS; }
        }
    }
}
