using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SharpProxyService
{
    public partial class fSettings : Form
    {
        public fSettings()
        {
            InitializeComponent();
        }
        //bool Adding = false;
        Rule CurrentEditRule = null;
        private void fSettings_Load(object sender, EventArgs e)
        {
            ReadRules();
            RULES_LIST.SelectedIndexChanged += new EventHandler(RULES_LIST_SelectedIndexChanged);
        }

        void RULES_LIST_SelectedIndexChanged(object sender, EventArgs e)
        {
            //fill data with props
            if (RULES_LIST.SelectedItems.Count == 1) 
            { 
                //search rule
                lock (Mod_ReWrite.MyConfig.Rules) 
                {
                    foreach (Rule R in Mod_ReWrite.MyConfig.Rules) 
                    { 
                        if (R.URL_LIKE_MASK.Equals(RULES_LIST.SelectedItems[0].Text))
                        {
                            CurrentEditRule = R;

                            Change_REFERER.Checked  = R.Change_REFERER;
                            Change_UA.Checked = R.Change_UA;
                            Change_URL.Checked = R.Change_URL;
                            REFERER_Change_Pattern.Text = R.REFERER_Change_Pattern;
                            UA_Change_Pattern.Text = R.UA_Change_Pattern;
                            URL_Change_Pattern.Text = R.URL_Change_Pattern;
                            URL_LIKE_MASK.Text = R.URL_LIKE_MASK;

                            //Adding = false;
                            return;
                        }
                    }
                }
                Change_REFERER.Checked = false;
                Change_UA.Checked = false;
                Change_URL.Checked = false;
                REFERER_Change_Pattern.Text = "";
                UA_Change_Pattern.Text = "";
                URL_Change_Pattern.Text = "";
                URL_LIKE_MASK.Text = "";
                CurrentEditRule = null;
            }
        }

        void ReadRules() 
        {
            RULES_LIST.Items.Clear();
            RULES_LIST.BeginUpdate();
            lock (Mod_ReWrite.MyConfig.Rules) 
            {
                foreach (Rule R in Mod_ReWrite.MyConfig.Rules) 
                {
                    RULES_LIST.Items.Add(R.URL_LIKE_MASK);
                }
            }
            RULES_LIST.EndUpdate();
            Change_REFERER.Checked = false;
            Change_UA.Checked = false;
            Change_URL.Checked = false;
            REFERER_Change_Pattern.Text = "";
            UA_Change_Pattern.Text = "";
            URL_Change_Pattern.Text = "";
            URL_LIKE_MASK.Text = "";
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //save
            if (CurrentEditRule != null)
            {




                CurrentEditRule.Change_REFERER = Change_REFERER.Checked;
                CurrentEditRule.Change_UA = Change_UA.Checked;
                CurrentEditRule.Change_URL = Change_URL.Checked;
                CurrentEditRule.REFERER_Change_Pattern = REFERER_Change_Pattern.Text;
                CurrentEditRule.UA_Change_Pattern = UA_Change_Pattern.Text;
                CurrentEditRule.URL_Change_Pattern = URL_Change_Pattern.Text;
                CurrentEditRule.URL_LIKE_MASK = URL_LIKE_MASK.Text;
                ReadRules();
            }


        }

        private void button1_Click(object sender, EventArgs e)
        {
            //new
            lock (Mod_ReWrite.MyConfig.Rules) 
            {
                Rule R = new Rule();
                R.URL_LIKE_MASK = "Enter URL like mask here";
                Mod_ReWrite.MyConfig.Rules.Add(R);
            }
            ReadRules();
            //RULES_LIST.SelectedItems[0] = 
            RULES_LIST.Items[RULES_LIST.Items.Count - 1].Selected = true;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Mod_ReWrite.MyConfig.Save();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            Mod_ReWrite.MyConfig.Verbose = checkBox1.Checked;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (CurrentEditRule != null) 
            {
                lock (Mod_ReWrite.MyConfig.Rules) 
                {
                    Mod_ReWrite.MyConfig.Rules.Remove(CurrentEditRule);
                }
                ReadRules();
            }
        }

    }
}